/*
**  WASABI-Hot! version 1.2c   
**
**
**      -- copyright (c) 2001-2004 by Philips Japan, Ltd. -- All rights reserved --
**
**
**      ** This code has been made to check/learn                          ** 
**      **                             the ISP1362/ISP1363 functionalities **
**      ** Release 06-Aug-2004                                             **
**
**      OKANO, Akifumi
**      
**		Application Laboratory, Mobile and Connectivity
**      Semiconductors Div, Philips Japan Ltd.
**      akifumi.okano@philips.com
**      +81-3-3740-4668 
*/


/****************************************************************************/
/*	includes																*/
/****************************************************************************/

#include		<conio.h>
#include		<stdlib.h>

#include		"_hc_core/isr.h"
#include		"_hc_core/transfer.h"


/****************************************************************************/
/*	constants																*/
/****************************************************************************/

#define			ABORT						0
#define			CONTINUE					1

#define			GENERAL_KEY_POLLING_RATE	0x3F				//	Rate for keyboard input polling
//#define			GENERAL_KEY_POLLING_RATE	0x7F				//	Rate for keyboard input polling
																//		The value will be defined (GENERAL_KEY_POLLING_RATE + 1)ms
																//		If you have 0x3FF, you will have a key input in every 1024ms.
																
#define			AUDIO_STATUS_MONITOR_LINE	1
#define			PRINTER_STATUS_MONITOR_LINE	2
#define			STORAGE_STATUS_MONITOR_LINE	5


#define			BG_BLUE	(BLUE << 4)


/****************************************************************************/
/*	types																	*/
/****************************************************************************/

typedef		struct	st_coodinate	{
										int		x;
										int		y;
									}
									coodinate;  


/****************************************************************************/
/*	global vars																*/
/****************************************************************************/

extern unsigned char	gp_key_polling_flag;
extern unsigned char	gp_beat_flag;

extern unsigned long	gp_debug_test0;
extern unsigned long	gp_debug_test1;

				
/****************************************************************************/
/*	function prototypes														*/
/****************************************************************************/

unsigned char	ui_user_debug_command_key( void );
unsigned char	ui_user_debug_command_handler( unsigned char command );
void			mprintf( unsigned char color, unsigned char mode, char *str, ... );
void			Dc_printf( unsigned char color, unsigned char mode, char *format, ... );
void			ui_status_monitor( void );
void			ui_beat( void );
void 			ui_install_status_monitor_custom_routine( unsigned char number, void (*custom_monitor)( unsigned char dummy ) );
void			ui_isr_flag_monitor( void );
void			ui_start_message( void );
void			ui_soft_blink( char *s, unsigned short interval, unsigned char repeat );
void 			ui_print_unicode( unsigned char color, unsigned short *str );
int				ui_unicode_to_C_string( char *target, unsigned short *source, int length );
void 			ui_show_device_string_descriptors( device_instance *dp );
void			ui_device_infomation_viewer( device_instance *dp );
unsigned char	ui_key_polling_timing( void );
int				ui_key_wait( void );
int				ui_key_in( void );
char			*ui_get_string_from_console( char *s, int length, unsigned char input_color, char *prompt_string, unsigned char prompt_color, char *suffix, char *preset_string, unsigned short *key );
void			ui_over_current_detected_message( unsigned char port );		//	##	version1.2c
void			ui_topology_view( device_instance *dvi_ptr, unsigned char depth, unsigned char bg_color );
void			ui_show_topology( void );
void			ui_show_current_time( unsigned char flag );


void			ui_ffree( void *p );			//	for debug
void			*ui_mmalloc( size_t s );		//	for debug

void			ui_debug_marker( unsigned short v );


/*

text color list from conio.h
^^^^^^^^^^^^^^^^^^^^^^^^^^^^
enum COLORS {
    BLACK,          // dark colors
    BLUE,
    GREEN,
    CYAN,
    RED,
    MAGENTA,
    BROWN,
    LIGHTGRAY,
    
    DARKGRAY,       // light colors
    LIGHTBLUE,
    LIGHTGREEN,
    LIGHTCYAN,
    LIGHTRED,
    LIGHTMAGENTA,
    YELLOW,
    WHITE
};
*/


