/*
**  WASABI-Hot! version 1.2c   
**
**
**      -- copyright (c) 2001-2004 by Philips Japan, Ltd. -- All rights reserved --
**
**
**      ** This code has been made to check/learn                          ** 
**      **                             the ISP1362/ISP1363 functionalities **
**      ** Release 06-Aug-2004                                             **
**
**      OKANO, Akifumi
**      
**		Application Laboratory, Mobile and Connectivity
**      Semiconductors Div, Philips Japan Ltd.
**      akifumi.okano@philips.com
**      +81-3-3740-4668 
*/

/****************************************************************************/
/*	includes																*/
/****************************************************************************/

#include		"_hc_core/dev_ep.h"
#include		"_hc_core/transfer.h"

#include		"class_dr/hub/hub.h"


/****************************************************************************/
/*	constants																*/
/****************************************************************************/

#define			NUMBER_OF_ROOT_HUB_PORT		2

/****************************************************************************/
/*	global vars																*/
/****************************************************************************/

extern hub_instance				gp_root_hub_instance;

extern unsigned char			gp_fast_enumeration;
extern unsigned char			gp_silent_enumeration;
extern unsigned char			gp_warning_message;


/****************************************************************************/
/*	function prototypes														*/
/****************************************************************************/

void				portctl_isr_flag_routine_dspatch( void );
device_instance		*portctl_device_on_port( unsigned char port_num );
void				portctl_force_rh_port_reconnect( void );
unsigned char		portctl_check_OTG_port( unsigned char bus_request, unsigned char full_enum );
void				portctl_disconnect_a_device_on_OTG_port( void );
device_instance		*portctl_get_OTG_port_device_instance( void );
void				portctl_OTG_port_enable_disable( unsigned char enable );
unsigned char		portctl_reset_OTG_port( void );
void				portctl_Vbus_control_for_port_1_or_2( unsigned char power, unsigned char port );




